"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var useSpeechMarks = function (speechMarks, isPlaying) {
    var noWordSelected = {
        index: -1,
        word: ""
    };
    var _a = React.useState(noWordSelected), currentWord = _a[0], setCurrentWord = _a[1];
    var timeoutHandles = React.useRef([]);
    React.useEffect(function () {
        return function () {
            timeoutHandles.current.forEach(clearTimeout);
        };
    }, []);
    React.useEffect(function () {
        isPlaying ? start() : stop();
    }, [isPlaying]);
    var start = function () {
        var _a;
        (_a = timeoutHandles.current).push.apply(_a, speechMarks
            .filter(function (speechMark) { return speechMark.value.length > 0; })
            .filter(function (speechMark) {
            var ssmlTagRegex = /<.*\/>/;
            var isSsmlTag = speechMark.value.match(ssmlTagRegex) !== null;
            return !isSsmlTag;
        })
            .map(function (speechMark, index) {
            return setTimeout(function () {
                return setCurrentWord({
                    index: index,
                    word: speechMark.value
                });
            }, speechMark.time);
        }));
    };
    var stop = function () {
        setCurrentWord(noWordSelected);
        timeoutHandles.current.forEach(clearTimeout);
    };
    return currentWord;
};
exports.default = useSpeechMarks;
//# sourceMappingURL=UseSpeechMarks.js.map