"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var unist_util_visit_1 = __importDefault(require("unist-util-visit"));
var getSsmlFromMdxAst_1 = __importDefault(require("./getSsmlFromMdxAst"));
// @ts-ignore
var unist_util_find_after_1 = __importDefault(require("unist-util-find-after"));
// @ts-ignore
var unist_util_find_all_between_1 = __importDefault(require("unist-util-find-all-between"));
var extractSpeechOutputId = function (startNode, speechOutputComponentName) {
    var value = startNode.value;
    var regex = new RegExp("<" + speechOutputComponentName + ".*id=\"([^\"]*)\".*>");
    var matches = value.match(regex);
    if (matches) {
        return matches[1];
    }
    else {
        throw new Error("Missing/invalid SpeechOutput ID prop found.");
    }
};
var extractSpeechOutputBlocks = function (mdxAst, speechOutputComponentName) {
    var speechOutputBlocks = [];
    var isStartNode = function (node) {
        var value = node.value;
        return (node.type === "jsx" &&
            value.startsWith("<" + speechOutputComponentName));
    };
    var isEndNode = function (node) {
        var value = node.value;
        return node.type === "jsx" && value === "</" + speechOutputComponentName + ">";
    };
    unist_util_visit_1.default(mdxAst, isStartNode, function (startNode, startNodeIndex, parent) {
        var relatedEndNode = unist_util_find_after_1.default(parent, startNode, isEndNode);
        var nodesToGetTextFrom = unist_util_find_all_between_1.default(parent, startNode, relatedEndNode);
        var text = nodesToGetTextFrom.map(getSsmlFromMdxAst_1.default).join("");
        var speechOutputId = extractSpeechOutputId(startNode, speechOutputComponentName);
        // TODO: also get voice parameter props and use them for generation (and check if they changed?)
        speechOutputBlocks.push({
            id: speechOutputId,
            text: text
        });
    });
    return speechOutputBlocks;
};
exports.default = extractSpeechOutputBlocks;
//# sourceMappingURL=extractSpeechOutputBlocks.js.map