"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defaultBreakTag = "<break time='1s'/>";
var mdastToSsmlString = function (node) {
    var ssmlString = "";
    if (node.type !== "jsx") {
        ssmlString = ssmlString.concat((node && node.value && node.value) || "");
    }
    var children = node.children;
    if (children) {
        ssmlString = ssmlString.concat(children.map(mdastToSsmlString).join(""));
    }
    if (node.type === "paragraph" || node.type === "heading") {
        ssmlString = ssmlString.concat(defaultBreakTag);
    }
    return ssmlString;
};
var getSsmlFromMdxAst = function (mdAst) {
    return mdastToSsmlString(mdAst);
};
exports.default = getSsmlFromMdxAst;
//# sourceMappingURL=getSsmlFromMdxAst.js.map